
Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #422

Tray icon invisible in LXDE-Qt

March 27, 2014 21:50 - Arthur Borsboom

Status: Rejected Start date: March 27, 2014

Priority: Minor Due date:  

Assignee:  % Done: 0%

Category: plugins/statusicon Estimated time: 0.00 hour

Target version:    

Affects version:    

Description

The audacious tray icon is in the systray and functioning, but not visible, see attachment.

It seems to be exactly the same issue as bug #121, however the offered solutions do not resolve the issue.

Things I have tried, but did not work:

Removing directory ~/.config/audacious

Rebuilding icon cache with "update-desktop-database -q" and "gtk-update-icon-cache -q -t -f /usr/share/icons/hicolor"

Changing to nvidia binary driver (I have a Intel videocard).

Things that are different than in bug #121:

I use LXQT instead of KDE (but both are based on Qt)

I have an Intel videocard instead of a Nvidia

All my other status icons do work

wicd

insync

xpad (uses GtkStatusIcon too)

volume

Using Arch with Lxqt with Audacious 3.5-beta1 (03/27/2014)

My gut feeling says it is an installation issue of Audacious or the Qt/Gtk environment.

Do you have any suggestions other than the above to try to fix this issue?

Thanks in advance!

History

#1 - March 28, 2014 13:30 - John Lindgren

So what do you expect Audacious developers to do?  It's not like there's a magical gtk_status_icon_show_in_lxqt() function we can call to fix this.

#2 - March 28, 2014 14:35 - Arthur Borsboom

Hi John,

I am not sure if the cause is in Audacious or in the environment. But I do know, that my sticky notes application Xpad, uses the GtkStatusIcon too and

it does show up. There is no magic lxqt code involved. :)

Maybe it has something to do with the way the icon theme is set in Audacious?

Here is a piece of 'tray-code' extracted from Xpad, maybe that helps?

static GtkStatusIcon  *docklet = NULL;

static GtkWidget *menu = NULL;

void

xpad_tray_open ()

{

    GtkIconTheme *theme;

    theme = gtk_icon_theme_get_default ();
    if (!gtk_icon_theme_has_icon (theme, PACKAGE)) {

        return;

    }

    if (gtk_icon_theme_has_icon (theme, "xpad-panel"))

    {

        docklet = gtk_status_icon_new_from_icon_name ("xpad-panel");

    }

    else

    {

        docklet = gtk_status_icon_new_from_icon_name (PACKAGE);

    }

    if (docklet)

    {

        g_signal_connect (docklet, "activate", G_CALLBACK (xpad_tray_activate_cb), NULL);

        g_signal_connect (docklet, "popup-menu", G_CALLBACK (xpad_tray_popup_menu_cb), NULL);

    }

}

 

Does this give you some inspiration for analyzing this issue?

Cheers,

Arthur.

#3 - March 28, 2014 15:00 - Arthur Borsboom

Hi John,

I have an interesting discovery to share.

The Xpad version where the status icon works, is version 4.2. I have developed and released this version. It is based on GTK2.

Now, I had a hunch that GTK3 might be part of the cause of this. I looked up the GTK version of Audacious and it is GTK3. Let's not go into my

annoyances of GTK, so ... <forget, darned, forget> :)

I compiled a GTK3 version which I was developing of Xpad, v4.3. And of course you can guess it by now: the status icon has exactly the same

behavior as Audacious.

If I have more new information regarding this topic, I will share it.

If something comes up on your mind, please feel free to share.

That can help.

Cheers,
Arthur.

#4 - March 29, 2014 04:10 - John Lindgren

Maybe the GTK3 version is using a newer/incompatible protocol that a Qt-based tray implementation does not like?  That's my guess, given that it

seems to be the combination of GTK3 and Qt that is the problem.

#5 - April 01, 2014 02:16 - Anon Ym

Confirmed for Debian/Jessie with GTK+ (3.10.7-1) and Audacious (3.4.3-1).

#6 - April 01, 2014 04:50 - John Lindgren

Anon Ym wrote:

Confirmed for Debian/Jessie with GTK+ (3.10.7-1) and Audacious (3.4.3-1).

 

What is confirmed?

#7 - April 01, 2014 04:51 - John Lindgren

- Category set to plugins/statusicon

#8 - April 02, 2014 00:43 - Anon Ym

John Lindgren wrote:

What is confirmed?

 

The bug of course.

#9 - April 02, 2014 06:20 - John Lindgren

Anon Ym wrote:

The bug of course.

 

Sorry, but I am still trying to figure out what "the bug" is.  If you know more about it than I do, then please write a patch to fix it. Otherwise, give some

details about what you are "confirming".  Are you also running LXQT?  Or do you use KDE on an NVidia graphics card with the nouveau driver, as in 

#121?  Or something else entirely?
#10 - April 02, 2014 11:53 - Arthur Borsboom

Hi John,

... given that it seems to be the combination of GTK3 and Qt that is the problem.

 

This is my current assumption too.

Do you feel like investigating this issue together?

If no, I will switch audio player and we can close this bug report.

If yes (what I prefer), do you have some suggestions how to approach this?

#11 - April 02, 2014 13:48 - John Lindgren

I would suggest contacting the LXQT developers about the problem first, to see if they are aware of it or can give any additional clues.  Also compare

the GTK2 and GTK3 status icon code looking for any difference that might cause such a problem.  If you have time, you could also install KDE to

check whether your GTK-vs.-Qt hunch has any merit.

#12 - April 02, 2014 14:11 - Arthur Borsboom

Okay, that sounds like a plan.

I will go work on it.

This might take some time, though.

Cheers,

Arthur.

#13 - April 02, 2014 14:47 - Arthur Borsboom

Step 1.

Contacting lxqt developers --> done and awaiting answer.

https://github.com/lxde/lxqt-panel/issues/23

#14 - April 02, 2014 14:59 - Arthur Borsboom

Step 2.

Comparing GTK2 and GTK3 statusIcon source code.

I have looked at it, but this one is a bit over my head. I have not enough knowledge of GTK to be able to find a possible cause. Would you mind and

look through the code to see if you can find any clues? To make it easier, here are the two different sources.

https://git.gnome.org/browse/gtk+/tree/gtk/gtkstatusicon.c?h=gtk-2-24

https://git.gnome.org/browse/gtk+/tree/gtk/gtkstatusicon.c?h=gtk-3-10

In the mean time, I will go ahead and install KDE on one of my Linux distro's to see if I can replicate the same behavior of Audacious 3.5 and Xpad
v4.3 (GTK3).

#15 - April 02, 2014 17:07 - John Lindgren

I don't see any changes in gtkstatusicon.c that should cause a problem.  There could still be some subtle difference in a base class (such as

GtkWidget) that is causing trouble for LXQT.

#16 - April 02, 2014 23:18 - Arthur Borsboom

Step 3.

Testing in KDE

I have installed on an existing Lubuntu environment (LXDE), the package kubuntu-desktop (KDE). I have logged into KDE and started Audacious with

the status icon plugin enabled. The icon was visible, concluding to me that Qt is not the issue. Maybe it is a mix of things, or something currently out

of our scope.

What do you suggest next?

#17 - April 03, 2014 05:04 - John Lindgren

- Subject changed from Tray icon invisible to Tray icon invisible in LXDE-Qt

All right, we know that the icon shows up fine in KDE, XFCE, and old-style LXDE (I tested the last two).  So only in LXQT is there a problem.  I am

therefore inclined to assume that there is a flaw in LXQT -- but we should wait and see what response comes back from the LXQT developers.

#18 - April 03, 2014 08:08 - Arthur Borsboom

Agreed. Thanks John.

#19 - April 08, 2014 22:44 - Arthur Borsboom

Hi John,

I had an interesting discovery regarding this issue.

Please read my comment here.

https://github.com/lxde/lxqt-panel/issues/23

Cheers,

Arthur.

#20 - April 13, 2014 10:20 - Arthur Borsboom

Hi John,

As we started to suspect, the issue was in LXQT.

Yesterday a patch has been released, which resolved this issue.

https://github.com/lxde/lxqt-panel/issues/23#issuecomment-40285673

You can close this bug report.

Cheers,
Arthur.

#21 - April 15, 2014 13:58 - John Lindgren

- Status changed from New to Rejected

Okay, not a bug in Audacious then.  Closing.
